
#include <iostream>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glext.h>
#include <SDL/SDL.h>
#include <SDL/SDL_thread.h>
#include <math.h>
#include "model.h"
#include "engine.h"

#define FOV 45.0
using namespace std;
const SDL_VideoInfo* vinfo = NULL;
SDL_Surface * surf=NULL;
SDL_Event event;
SDL_Thread *thread;
mscoll mod[6];
int width=640;
int height=480;
int bpp=16;
int notdone=1;
int viewmove;
int seln; // pickinghez kell
char thinking=0; //ide c h a r kell
int moved=0;
Uint32 vflags=SDL_OPENGL|SDL_DOUBLEBUF|SDL_HWPALETTE|SDL_RESIZABLE;
GLfloat clearcol[4]={0.2,0.5,1.0,1.0};
GLuint texture;

ttabla xt=      {{{ 6,12, 4, 8,10, 4,12, 6},
                  { 2, 2, 2, 2, 2, 2, 2, 2},
                  { 0, 0, 0, 0, 0, 0, 0, 0},
                  { 0, 0, 0, 0, 0, 0, 0, 0},
                  { 0, 0, 0, 0, 0, 0, 0, 0},
                  { 0, 0, 0, 0, 0, 0, 0, 0},
                  { 3, 3, 3, 3, 3, 3, 3, 3},
                  { 7,13, 5, 9,11, 5,13, 7}} ,0,0};
GLfloat	rotdx=25.0;
GLfloat rotdy=0,rotdz=0,tr=0;
GLfloat rotvx=0,rotvy=0,rotvz=0,trv=0;
int thread_func(void *unused)
{
    ttabla yt;
    yt=xt;
    nsearch(0,0,1,&yt,-30000,30000,1); 
    xt=yt;
    thinking=0;
}
void ResizeWindow(int width,int height)
{
  if (height<=0) height=1;
  glViewport(0,0,width,height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(FOV,(float)width/(float)height,0.1,100.0);
  glMatrixMode(GL_MODELVIEW );
  glLoadIdentity();
}
int InitGL()
{
    SDL_Surface * img;
    GLfloat gambient[]={0.3,0.3,0.3,1.0}; // general ambient light
    GLfloat LightDiffuse[]= { 1.0f, 1.0f, 1.0f, 1.0f };
    glShadeModel(GL_SMOOTH);
	glClearColor(clearcol[0],clearcol[1],clearcol[2],clearcol[3]);
	glClearDepth(1.0f);
	glEnable(GL_DEPTH_TEST);
	glEnable( GL_TEXTURE_2D );
	glDepthFunc(GL_LEQUAL);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
    glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT1);glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);
	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_FALSE); //one sided lightning
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT,gambient); //general ambient light
    glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER,GL_TRUE);
    glEnable(GL_CULL_FACE);
    glCullFace(GL_BACK);
    LoadModel(&mod[0],"models/paraszt.ms3d");    
    LoadModel(&mod[1],"models/futo.ms3d");
    LoadModel(&mod[2],"models/bastya.ms3d");
    LoadModel(&mod[3],"models/kiralyno.ms3d");
    LoadModel(&mod[4],"models/kiraly.ms3d");
    LoadModel(&mod[5],"models/lo.ms3d");  
    img=SDL_LoadBMP("models/Wood.bmp");
    glGenTextures( 1, &texture );
    glBindTexture(GL_TEXTURE_2D,texture);
    glTexImage2D(GL_TEXTURE_2D,0,3,img->w,img->h,0,GL_BGR,GL_UNSIGNED_BYTE,img->pixels);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    SDL_FreeSurface(img);
}
void DrawTable(void)
{
    int i,j,k;
    GLfloat tambientanddiffuse[2][4]={{0.3,0.3,0.3,0.65},{0.9,0.9,0.9,0.65}};
    GLfloat tsambientanddiffuse[2][4]={{1,0.3,0.3,0.65},{1,0.4,0.4,0.65}};
    GLfloat tspecular[2][4]={{0.3,0.3,0.3,0.9},{0.3,0.3,0.3,0.9}};
    GLfloat tshininess[2]={60.0,60.0};
    /*for (k=0;k<2;k++) {*/ 
    {
           for (i=0;i<8;i++) for (j=0;j<8;j++) {//if ((i+j+1)%2==k) {
	   k= ((i+j+1)%2);
	    glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,&tambientanddiffuse[k][0]);
        glMaterialfv(GL_FRONT,GL_SPECULAR,&tspecular[k][0]);
        glMaterialf(GL_FRONT,GL_SHININESS,tshininess[k]);
       if (seln); if (IsMoveOk(&xt,(seln-1)&7,(seln-1)>>3,i,j,1)) {
        glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,&tsambientanddiffuse[k][0]);
	}
               glLoadName(j*8+i+1);
               glBegin(GL_QUADS);
                 glNormal3f(0.0,1.0,0.0);
                 glTexCoord2f(0,0);
                 glVertex3f(0.0+i*2.0,0.0,0.0+j*2.0);
                 glTexCoord2f(0,1);
                 glVertex3f(0.0+i*2.0,0.0,2.0+j*2.0);
                 glTexCoord2f(1,1);
                 glVertex3f(2.0+i*2.0,0.0,2.0+j*2.0);
                 glTexCoord2f(1,0);
                 glVertex3f(2.0+i*2.0,0.0,0.0+j*2.0);
               glEnd();
           }
    }    
}
void DrawObjects(void)
{
    int i,j,k,l,index;
    GLfloat ambientanddiffuse[2][4]={{0.3,0.3,0.3,1.0},{0.9,0.9,0.9,1.0}};
    GLfloat specular[2][4]={{0.7,0.7,0.7,1.0},{0.7,0.7,0.7,1.0}};
    GLfloat shininess[2]={60.0,60.0};
    for (k=0;k<2;k++){
        glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,&ambientanddiffuse[k][0]);
        glMaterialfv(GL_FRONT,GL_SPECULAR,&specular[k][0]);
        glMaterialf(GL_FRONT,GL_SHININESS,shininess[k]);
        glPushMatrix();
        glTranslatef(1.0,0.0,1.0);
        for (i=0;i<8;i++){
            glPushMatrix();
            for (j=0;j<8;j++){
                if ((xt.tabla[i][j] & 1) == k) {
                    glLoadName(i*8+j+1);
                    index=(xt.tabla[i][j] >> 1)-1;
                    if (index>=0) {
                        if (((i << 3 ) | j)+1 == seln) {
                            glPushMatrix();
                            glTranslatef(0,0.4,0);
                        DrawModel(&mod[index]);
                        glPopMatrix();
                    } else DrawModel(&mod[index]);
                    }    
                }
                glTranslatef(2.0,0.0,0.0);    
            }
            glPopMatrix();
            glTranslatef(0.0,0.0,2.0);
        }      
        glPopMatrix();
    }    
}
    GLfloat lightpos[]={8.0,10.0,8.0,1.0};
    GLfloat lightpos2[]={8.0,10.0,8.0,1.0};
    GLfloat brig[4]={0.9,0.9,0.9,1.0};
    GLfloat ll=0;
int DrawGLScene()
{        
int i,j; int h=-1;
         lightpos[0]=8+12*sin(ll);
         lightpos[2]=8+12*cos(ll);
	 
	 lightpos2[0]=8+12*sin(ll+3.14);
         lightpos2[2]=8+12*cos(ll+3.14);
         ll=ll+3.14/550.0;
    if (!moved) { rotdy+=0.8; 
      tr=-10+10*sin(rotdy*1.5*3.14/180.0);
    }
    if (viewmove) moved=1;
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	glLoadIdentity();
    //  glLightfv(GL_LIGHT0,GL_POSITION,lightpos); 	 	  
    glTranslatef(0.0f,0.0f,-10+tr);	
    glRotatef(rotdx,1,0,0);
    glRotatef(rotdy,0,1,0);
    glRotatef(rotdz,0,0,1);
    glTranslatef(-8.0,0.0,-8.0); // translate a tabla kozepere
    
    glColorMask(0,0,0,0); // Nem Rajzolunk semmit
    glDisable(GL_LIGHTING); // Ha mar nem rajzolunk akkor feny se kell
    glDisable(GL_TEXTURE_2D); // Texturak se kellenek. (lehet hogy ez az utolso ket sor nem gyorsit)
    glEnable(GL_STENCIL_TEST); // Megjegyezzuk a tabla helyet
    glStencilFunc(GL_ALWAYS, 1, 1);
    glStencilOp(GL_KEEP, GL_KEEP, GL_REPLACE);
    glDisable(GL_DEPTH_TEST);
    DrawTable(); 
    glEnable(GL_DEPTH_TEST);
	glColorMask(1,1,1,1);	
    glEnable(GL_LIGHTING);
    glEnable(GL_TEXTURE_2D);
    glStencilFunc(GL_EQUAL, 1, 1);
    glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
    
    glPushMatrix();
 	  glScalef(1.0,-1.0,1.0);
 	    glLightfv(GL_LIGHT0,GL_POSITION,lightpos); 	 	
	    glLightfv(GL_LIGHT1,GL_POSITION,lightpos2); 	 	
 	  glFrontFace(GL_CW);
 	    DrawObjects();
 	  glFrontFace(GL_CCW);
    glPopMatrix(); 
    glDisable(GL_STENCIL_TEST);
      glLightfv(GL_LIGHT0,GL_POSITION,lightpos); 	 	
      glLightfv(GL_LIGHT1,GL_POSITION,lightpos2); 	 	
    /*  glPushMatrix();
      glTranslatef(lightpos[0],lightpos[1],lightpos[2]);
      DrawModel(&mod[0]);*/
      glPopMatrix();
 	  glEnable(GL_BLEND);
        glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
// glDisable(GL_TEXTURE_2D);	
    DrawTable(); 
    //glEnable(GL_TEXTURE_2D);
 	  glDisable(GL_BLEND);
 	DrawObjects();
	glBegin(GL_QUADS);
    glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,brig);
    //alja
       glNormal3f(0,-1,0);
    glTexCoord2f(0,0);
	glVertex3f( 0,h, 0);
	glTexCoord2f(0,1);
	glVertex3f(16,h, 0);
	glTexCoord2f(1,1);
	glVertex3f(16,h,16);
	glTexCoord2f(1,0);
	glVertex3f( 0,h,16);
	//szembe
	    glNormal3f(0,0,1);
    glTexCoord2f(0,0);
	glVertex3f(0,h,16);
	glTexCoord2f(0,1);
	glVertex3f(16,h,16);
	glTexCoord2f(1,1);
	glVertex3f(16,0,16);
	glTexCoord2f(1,0);
	glVertex3f(0,0,16);
	
	//hata
		glNormal3f(0,0,-1);
		glTexCoord2f(0,0);
	glVertex3f(0,h,0);
	glTexCoord2f(0,1);
	glVertex3f(0,0,0);
	glTexCoord2f(1,1);
	glVertex3f(16,0,0);
	glTexCoord2f(1,0);
	glVertex3f(16,h,0);
	
	//jobboldal
	glNormal3f(1,0,0);
	glTexCoord2f(0,0);
	glVertex3f(16,0,16);
	glTexCoord2f(0,1);
	glVertex3f(16,h,16);
	glTexCoord2f(1,1);
	glVertex3f(16,h,0);
	glTexCoord2f(1,0);
	glVertex3f(16,0,0);	
	//baloldal
	glNormal3f(-1,0,0);
	glTexCoord2f(0,0);
	glVertex3f(0,0,16);
	glTexCoord2f(0,1);
	glVertex3f(0,0,0);	
	glTexCoord2f(1,1);
    glVertex3f(0,h,0);
    glTexCoord2f(1,0);
	glVertex3f(0,h,16);


	glEnd();
	
	
 /*  glLoadIdentity(); 
   glDisable(GL_LIGHTING);
   glEnable(GL_BLEND);
   glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
   glDisable(GL_TEXTURE_2D);
   glColor4f(0,0,0,0.5);
   glClear(GL_DEPTH_BUFFER_BIT);	  
   glBegin(GL_QUADS);
          glVertex3f(-1,-1,-0.1);
	  glVertex3f( 1,-1,-0.1);
	  glVertex3f( 1, 1,-0.1);
	  glVertex3f(-1, 1,-0.1);
   glEnd();
   glClear(GL_DEPTH_BUFFER_BIT);	  
   
   glEnable(GL_TEXTURE_2D);
   glEnable(GL_LIGHTING);
   glDisable(GL_BLEND);*/
   rotdy+=rotvy;   rotdx+=rotvx;   rotdz+=rotvz; tr+=trv;
 SDL_GL_SwapBuffers();
}
int SelectNum(int x_mousec,int y_mousec)
{
    GLuint buffer[512];
    GLint viewport[4],objs;
    int i,c,d;
    glGetIntegerv(GL_VIEWPORT, viewport);
    glSelectBuffer(512,buffer);
    glRenderMode(GL_SELECT);
    glInitNames();
    glPushName(0);
    glMatrixMode(GL_PROJECTION);
      glPushMatrix();
        glLoadIdentity();
        gluPickMatrix((GLdouble) x_mousec, (GLdouble) (viewport[3]-y_mousec), 1.0f, 1.0f, viewport);
        gluPerspective(FOV, (GLfloat)(viewport[2]-viewport[0])/(GLfloat)(viewport[3]-viewport[1]), 0.1f, 100.0f);
        glMatrixMode(GL_MODELVIEW);
          DrawTable();
          DrawObjects();
        glMatrixMode(GL_PROJECTION);
      glPopMatrix();
    glMatrixMode(GL_MODELVIEW);
    objs = glRenderMode(GL_RENDER);
    if (objs>0) {
        c = buffer[3];
        d = buffer[1];
        for (i=1;i<objs;i++) if(buffer[(i<<2)+1]<d) { c=buffer[(i<<2)+3]; d=buffer[(i<<2)+1];}
        return c;       
    } else {return 0;}
}    
void DoDownSelect(int xx, int yy){
    int c;
    if (thinking) return;
    c=SelectNum(xx,yy);
    if (xt.tabla[(c-1)>>3][(c-1) & 7 ] & 1) seln=c;    
}
void DoUpSelect(int xx, int yy){
    int c,cc,x1,y1,x2,y2;
    c=SelectNum(xx,yy);
    cc=seln;
    seln=0;
    if(!(  ((c==0)||(cc==0))  )) {
        c--;cc--;
	y1=cc>>3; x1=cc&7; y2=c>>3; x2=c&7;
	if (IsMoveOk(&xt,x1,y1,x2,y2,1)) {
        xt.tabla[y2][x2]=xt.tabla[y1][x1];
        xt.tabla[y1][x1]=0;
	
	thinking=1;
	// itten letrehozzuk a thread-et
	thread=SDL_CreateThread(thread_func, NULL);
	
	}
    }
    seln=0;
} 

int main(int argc, char* * argv)
{   
  SDL_Init(SDL_INIT_VIDEO); 
  atexit(SDL_Quit);
  vinfo=SDL_GetVideoInfo();
  if (vinfo->hw_available!=0) {vflags|=SDL_HWSURFACE;} else {vflags|=SDL_SWSURFACE;}
  if (vinfo->blit_hw!=0) {vflags|=SDL_HWACCEL;}
  bpp=vinfo->vfmt->BitsPerPixel;
  SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
  SDL_GL_SetAttribute( SDL_GL_STENCIL_SIZE, 1 );
  SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
  SDL_WM_SetCaption("Jatek",NULL);
  surf=SDL_SetVideoMode( width,height,bpp,vflags);
  ResizeWindow(width, height);
  InitGL();
  while(notdone) {
    DrawGLScene();
    while(SDL_PollEvent(&event)){
      switch( event.type ) {
        case SDL_KEYDOWN:
            switch( event.key.keysym.sym ) {
              case SDLK_ESCAPE:
                 notdone=0;
                 break;
              case SDLK_SPACE:
                 break;
              case SDLK_LEFT:
                rotvy=1;
                break;
              case SDLK_RIGHT:
                rotvy=-1;
                break;   
              case SDLK_UP:
                rotvx=1;
                break;
              case SDLK_DOWN:
                rotvx=-1;
                break;                        
              case SDLK_z:
                trv=1;
                break;
              case SDLK_x:
                trv=-1;
                break;                        

              default:
                 break;
            }
            break;
        case SDL_KEYUP:
            switch( event.key.keysym.sym ) {
              case SDLK_LEFT:
                rotvy=0;
                break;
              case SDLK_RIGHT:
                rotvy=0;
                break;          
              case SDLK_UP:
                rotvx=0;
                break;
              case SDLK_DOWN:
                rotvx=0;
                break;
              case SDLK_z:
                trv=0;
                break;
              case SDLK_x:
                trv=0;
                break;
              default:
                 break;
            }
            break;
        case SDL_MOUSEBUTTONDOWN:
            switch (event.button.button) {
                case SDL_BUTTON_LEFT:
                     if (viewmove<=0) {
                         DoDownSelect(event.button.x,event.button.y);
                         viewmove=-1;
                     } else viewmove=2;
                     break; 
                case SDL_BUTTON_RIGHT:
                     if (viewmove==0) viewmove=1;
                     break;
                case SDL_BUTTON_MIDDLE:
                     if (viewmove==0) viewmove=2; 
/*                case SDL_BUTTON_WHEELDOWN:
                     tr-=2;
                     break;
                case SDL_BUTTON_WHEELUP:
                     tr+=2;
                     break; */
                default:
                     break;             
            }       
            break; 
        case SDL_MOUSEBUTTONUP:
            switch (event.button.button) {
                case SDL_BUTTON_LEFT:
                     if (viewmove==-1) {
                         DoUpSelect(event.button.x,event.button.y);              
                           viewmove=0;
                     }
                     break; 
                case SDL_BUTTON_RIGHT:
                     if (viewmove>0) viewmove=0;
                     break;
                case SDL_BUTTON_MIDDLE:
                     if (viewmove>0) viewmove=0;
                     break;  
                default:
                     break;              
            }       
            break; 
        case SDL_MOUSEMOTION:
             if (viewmove==1) {
                              rotdy+=(event.motion.xrel)/2.0;
                              rotdx+=(event.motion.yrel)/2.0;
                              }
             if (viewmove==2) {
                              tr+=(event.motion.yrel)/10.0;
                              rotdy+=(event.motion.xrel)/2.0;
                              }
             break;    
        case SDL_QUIT:
            notdone=0;
            break;
        case SDL_VIDEORESIZE:
            width=event.resize.w; height=event.resize.h;
            surf=SDL_SetVideoMode(width,height,bpp, vflags );
            InitGL();
            ResizeWindow(width,height);
            break;
        }
    }
  }
  return 0;
}
